// librairie de gestion des répertoires et fichiers
const fs = require('fs')
const path = require('path')

// librairie de gestion des arguments de la ligne de commande
var argv = require('optimist').argv

// libvrairie de lecture de lignes de texte
var readline = require('readline')

// librairie de traitement du pinyin
// const pinyinizer = require('pinyinizer')
// librairie de gestion du hanzi
// const opencc = require('node-opencc')

// librairie de gestion des fichiers csv
var csv = require('comma-separated-values')

// Nom du fichier entrée csv
// en entrée, on donne le nom du fichier à traiter sans le répertoire
var repertoireInitial = './'
var argument = argv._[0]

fichierDonnées = path.join(repertoireInitial, argument)
// DEBUG
// console.log(fichierDonnées);


// Nom du fichier xml
fichierXml = fichierDonnées.replace('.csv','.xml')
// DEBUG
console.log(fichierXml)

var tab = "\t"
var rc  = "\n"

var ligne = {
  numero: '',
  pinyin: '',
  hanzi: '',
  translation: ''
}

function resetLigne () {
  numero = ''
  pinyin = ''
  hanzi = ''
  translation = ''
}

// la ligne CSV qu'on lit
var ligneCSV = ''

prelude = `
<informaltable colsep="0" rowsep="0" frame="none">
<tgroup cols="2">
    <colspec colname="c1" colnum="1" colwidth="1.0*" align="center"/>
    <colspec colname="c2" colnum="2" colwidth="15.0*" align="left"/>
    <tbody>
`
fin = `
    </tbody>
  </tgroup>
</informaltable>
`

// on crée et ouvre le fichier de sortie xml
var monxml = fs.createWriteStream(fichierXml);

// on ouvre et lit le fichier csv
var fichierATraiter = fs.readFileSync(fichierDonnées, "UTF-8");

var moncsv = new csv(fichierATraiter, {
  header: [
      'numero',
      'pinyin',
      'hanzi',
      'translation'
    ],
  cast: [
      'String',
      'String',
      'String',
      'String'
    ]
}).parse();

// écriture du prélude
monxml.write(prelude)
monxml.write(rc)

// transformation et écriture des lignes dans le fichier xml
moncsv.forEach(function(enregistrement){
  // DEBUG
  // try {
  // console.log(enregistrement.numero)
  // console.log(enregistrement.pinyin)
  // console.log(enregistrement.hanzi)
  // console.log(enregistrement.translation)
  // } catch (err) {
  //   console.log (erreur)
  // }
  monxml.write('<row>')
  monxml.write(rc)
  monxml.write(tab)
  monxml.write('<entry>')
  monxml.write(enregistrement.numero)
  monxml.write('</entry>')
  monxml.write(rc)
  monxml.write(tab)
  monxml.write('<entry><foreignphrase xml:lang="cmn-Latn-pinyin">')
  monxml.write(enregistrement.pinyin)
  monxml.write('</foreignphrase></entry>')
  monxml.write(rc)
  monxml.write('</row>')
  monxml.write(rc)

  monxml.write('<row>')
  monxml.write(rc)
  monxml.write(tab)
  monxml.write('<entry/>')
  monxml.write(rc)
  monxml.write(tab)
  monxml.write('<entry><foreignphrase xml:lang="cmn-Hani">')
  monxml.write(enregistrement.hanzi)
  monxml.write('</foreignphrase></entry>')
  monxml.write(rc)
  monxml.write('</row>')
  monxml.write(rc)

  monxml.write('<row>')
  monxml.write(rc)
  monxml.write(tab)
  monxml.write('<entry/>')
  monxml.write(rc)
  monxml.write(tab)
  monxml.write('<entry>')
  monxml.write(enregistrement.translation)
  monxml.write('</entry>')
  monxml.write(rc)
  monxml.write('</row>')
  monxml.write(rc) 
  monxml.write('<row><entry/><entry/></row>')
  resetLigne()
})

// écriture de la fin dans le fichier xml
monxml.write(fin)

// fermeture du fichier de sortie xml
monxml.end()

